"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @file Lance le serveur configuré dans {@link app.ts}
 * @author manifold
 */
const dotenv_1 = __importDefault(require("dotenv")); //loads environment variables from (hidden) .env file into process.env
dotenv_1.default.config();
const app_1 = __importDefault(require("./app"));
const colors_1 = __importDefault(require("colors"));
const port = process.env.PORT;
const hostnameConfigMap = {
    'development': 'localhost',
    'staging': '0.0.0.0',
    'production': '0.0.0.0'
};
const hostname = process.env.HOST || hostnameConfigMap[process.env.TARGET_ENV];
app_1.default.listen(port, () => {
    console.log(colors_1.default.blue("🚀  Server ready on %s:%s."), hostname, port);
});
//# sourceMappingURL=index.js.map